Attribute VB_Name = "Module1"
Option Explicit
Public oServer As core.CServer
Public m_sName As String
Public Const CLASS_TrayProc As String = "Shell_TrayWnd"

Public curTray() As NOTIFYICONDATA

Public m_hWnd      As Long

Public g_SysTray           As Long
Public g_ConnectionTray    As Long
Public g_ConLAN            As Long


Public g_fIsWindows2000     As Boolean
Public g_fIsNT              As Boolean


Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Public Type COSERVERINFO
    dwReserved1 As Long ' DWORD
    pwszName As Long ' LPWSTR
    pAuthInfo As Long ' COAUTHINFO*
    dwReserved2 As Long ' DWORD
End Type

Public Type MULTI_QI
    piid As Long ' const IID*
    pItf As Object ' IUnknown*
    hr As Long ' HRESULT
End Type

Public Const S_OK As Long = 0

Public Const CLASS_E_NOAGGREGATION      As Long = &H80040110
Public Const REGDB_E_CLASSNOTREG        As Long = &H80040154
Public Const CO_E_CLASSSTRING           As Long = &H800401F3

Public Const E_INVALIDARG               As Long = &H80070057

Public Const E_NOINTERFACE              As Long = &H80004002

Public Const CLSCTX_INPROC_SERVER = 1
Public Const CLSCTX_INPROC_HANDLER = 2
Public Const CLSCTX_LOCAL_SERVER = 4
Public Const CLSCTX_REMOTE_SERVER = 16
Public Const CLSCTX_SERVER = CLSCTX_INPROC_SERVER + CLSCTX_LOCAL_SERVER + CLSCTX_REMOTE_SERVER
Public Const CLSCTX_ALL = CLSCTX_INPROC_SERVER + CLSCTX_INPROC_HANDLER + CLSCTX_LOCAL_SERVER + CLSCTX_REMOTE_SERVER

Public Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function IIDFromString Lib "ole32" (ByVal lpszIID As String, ByVal piid As Long) As Long
Public Declare Function CLSIDFromString Lib "ole32" (ByVal lpszCLSID As String, pclsid As GUID) As Long
Public Declare Function CLSIDFromProgID Lib "ole32" (ByVal lpszProgID As String, pclsid As GUID) As Long
Public Declare Function CoCreateInstanceEx Lib "ole32" (rclsid As GUID, ByVal pUnkOuter As Long, ByVal dwClsContext As Long, pServerInfo As COSERVERINFO, ByVal cmq As Long, rgmqResults As MULTI_QI) As Long
Public Declare Function CoCreateInstance Lib "ole32" (ByRef rclsid As GUID, ByVal pUnkOuter As Long, ByVal dwContent As Long, ByRef riid As GUID, ByRef ppv As Long) As Long

Public m_Items     As Long


Private Const x_e = 0
Public Function TrayWndProc(ByVal hWnd As Long, ByVal message As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

    Dim nicData As NOTIFYICONDATA
    Dim copyData As COPYDATASTRUCT
    Dim trayCmd As Long
    Dim dbgStr As String
    Dim hSysTray As Long
    Dim sTip As String * 255
    Dim i As Long

    Select Case message
    Case WM_TIMER
        Select Case wParam
        Case 0
            '
            ' restart the systray applet
            '
            hSysTray = FindWindow("SystemTray_Main", vbNullString)
            If hSysTray <> 0 Then
                Call SendMessage(hSysTray, WM_DESTROY, 0, 0)
            Else

                Call KillTimer(m_hWnd, 0&)
               
                If g_fIsWindows2000 Then
                    '
                    ' SysTray
                    '
                    Call StartComponent("SysTray", "{730F6CDC-2C86-11D2-8773-92E220524153}", g_SysTray)
                Else
                    '
                    ' launch the SysTray applet
                    '
                    Call ShellExecute(m_hWnd, "open", "systray.exe", vbNullString, vbNullString, SW_HIDE)
                End If
                '
                '
                '
'                Call PostMessage(HWND_BROADCAST, RegisterWindowMessage("TaskbarCreated"), ByVal 0&, ByVal 0&)
            
            End If
        End Select
   
    
    Case WM_COPYDATA
        Call CopyMemory(copyData, ByVal lParam, Len(copyData))
        Select Case copyData.dwData
        
        ' 0 is app bar message, 2 - unknown? win2k only?
        
        Case 1
            Call CopyMemory(nicData, ByVal copyData.lpData + 8, Len(nicData))
            Call CopyMemory(trayCmd, ByVal copyData.lpData + 4, 4)

            If g_fIsNT Then
                Call WideCharToMultiByte(CP_ACP, 0, nicData.szTip, -1, nicData.szTip, Len(nicData.szTip), 0, 0)
            End If

            Select Case trayCmd
            Case NIM_ADD
                dbgStr = "NIM_ADD -> " & nicData.szTip
                If oServer.evalBool(oServer.GetKey(m_sName, "debug")) Then
                    oServer.Execute "!log systray:" & dbgStr
                End If
                Call AddItem(nicData)

            Case NIM_MODIFY
                i = FindItem(nicData)
                If i Then
                    Call UpdateItem(i, nicData)
                    frmSystray.Picture1(i).Refresh
'                    Form1.Picture1(i).cls
'                    Call DrawIconEx(Form1.Picture1(i).hDC, _
'                                    4&, 4&, _
'                                    nicData.hIcon, _
'                                    16&, 16&, _
'                                    0&, 0&, DI_NORMAL)
'                    Form1.Picture1(i).ToolTipText = nicData.szTip
                End If
            
            Case NIM_DELETE
                If oServer.evalBool(oServer.GetKey(m_sName, "debug")) Then
                    oServer.Execute "!log systray:NIM_DELETE"
                End If
            
                i = FindItem(nicData)
                If i Then
                    RemoveItem i
                End If
            
            
            End Select
            
            If oServer.evalBool(oServer.GetKey(m_sName, "debug")) Then
                dbgStr = dbgStr & "  hWnd=" & nicData.hWnd & ", uID=" & nicData.uID & ", flags=0x" & Hex$(nicData.uFlags)
                oServer.Execute "!log systray:" & dbgStr
            End If

            TrayWndProc = CLng(True)
        
        Case Else
            TrayWndProc = DefWindowProc(ByVal hWnd, ByVal message, ByVal wParam, ByVal lParam)
        
        End Select
    
    Case Else
        TrayWndProc = DefWindowProc(ByVal hWnd, ByVal message, ByVal wParam, ByVal lParam)

    End Select

End Function
Private Sub AddItem(nidTrayItem As NOTIFYICONDATA)

    m_Items = m_Items + 1
    Load frmSystray.Picture1(m_Items)
    ReDim Preserve curTray(m_Items + 1)
    With frmSystray.Picture1(m_Items)
        curTray(m_Items) = nidTrayItem
        .Left = frmSystray.Picture1(m_Items - 1).Left + frmSystray.Picture1(0).Width + 2
        .Tag = IIf(nidTrayItem.uID = 0, nidTrayItem.hWnd, nidTrayItem.uID)
        .ToolTipText = nidTrayItem.szTip
        .Visible = True
    End With

    Call UpdateItem(m_Items, nidTrayItem)
        
End Sub
Private Function FindItem(nidTrayItem As NOTIFYICONDATA) As Long
    
    Dim lFind As Long
    Dim i As Long

    If m_Items > 0 Then
        lFind = IIf(nidTrayItem.uID = 0, nidTrayItem.hWnd, nidTrayItem.uID)
        For i = 1 To m_Items
            If CLng(IIf(curTray(i).uID = 0, curTray(i).hWnd, curTray(i).uID)) = lFind Then
                FindItem = i
                Exit Function
            End If
        Next i
    End If
    FindItem = 0

End Function
Public Sub UpdateItem(dwItem As Long, nidTrayItem As NOTIFYICONDATA)

    With frmSystray.Picture1(dwItem)
    
        .ToolTipText = nidTrayItem.szTip
        .cls
        Call DrawIconEx(.hdc, 0&, 0&, nidTrayItem.hIcon, 16&, 16&, 0&, 0&, DI_NORMAL)

    End With

End Sub
Private Sub RemoveItem(dwItem As Long)

    Dim i As Long

    If dwItem < m_Items Then
        For i = dwItem To m_Items - 1
            curTray(i) = curTray(i + 1)
            UpdateItem i, curTray(i)
            frmSystray.Picture1(i).Refresh
        Next
    End If
    Unload frmSystray.Picture1(m_Items)
    m_Items = m_Items - 1
    ReDim Preserve curTray(m_Items + 1)

End Sub
'
' :: These two need moving into some other module...
'
' Helper routine to initialize an OLE style GUID
Public Sub DefineOLEGuid(ByRef i As GUID, l As Long, w1 As Integer, w2 As Integer)
    
    i.Data1 = l
    i.Data2 = w1
    i.Data3 = w2
    i.Data4(0) = &HC0
    i.Data4(1) = 0
    i.Data4(2) = 0
    i.Data4(3) = 0
    i.Data4(4) = 0
    i.Data4(5) = 0
    i.Data4(6) = 0
    i.Data4(7) = &H46

End Sub

' Helper routine to set up a GUID from its string representation
Public Sub DEFINE_GUID(ByRef cls As GUID, l As Long, w1 As Integer, w2 As Integer, _
                       b1 As Byte, b2 As Byte, b3 As Byte, b4 As Byte, _
                       b5 As Byte, b6 As Byte, b7 As Byte, b8 As Byte)
    cls.Data1 = l
    cls.Data2 = w1
    cls.Data3 = w2
    cls.Data4(0) = b1
    cls.Data4(1) = b2
    cls.Data4(2) = b3
    cls.Data4(3) = b4
    cls.Data4(4) = b5
    cls.Data4(5) = b6
    cls.Data4(6) = b7
    cls.Data4(7) = b8

End Sub


Public Function StartComponent(szComponent As String, szCLSID As String, lpfnHandle As Long) As Long
Dim rclsid              As GUID
Dim hr                  As Long
Dim IID_IUnknown        As GUID

    Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
    Call CLSIDFromString(StrConv(szCLSID, vbUnicode), rclsid)
    hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, lpfnHandle)
    If hr Then
        oServer.Execute "!log " & szComponent & " failed, return code 0x" & Hex$(hr)
    End If

End Function



                '
                ' Connections Tray
                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{7007ACCF-3202-11D1-AAD2-00805FC1270E}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_ConnectionTray)
               
                '
                ' Dialup Connection
                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{7007ACC1-3202-11D1-AAD2-00805FC1270E}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_ConnectionTray)
'                '
'                ' Direct Connection
'                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{7007ACC2-3202-11D1-AAD2-00805FC1270E}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_ConnectionTray)
'                '
'                ' Inbound Connection
'                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{7007ACC3-3202-11D1-AAD2-00805FC1270E}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_ConnectionTray)
                '
                ' LAN Connection
                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{7007ACC5-3202-11D1-AAD2-00805FC1270E}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_ConnectionTray)
'                '
'                ' VPN Connection
'                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{7007ACC6-3202-11D1-AAD2-00805FC1270E}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_ConnectionTray)
'                '
'                ' Network & DU Connections
'                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{7007ACC7-3202-11D1-AAD2-00805FC1270E}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_ConnectionTray)
'                '
'                ' Connections Enum
'                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{7007ACC8-3202-11D1-AAD2-00805FC1270E}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_ConnectionTray)
                
                
                '
                ' from mian's Graphite shell (thanks Damian!) let's kickstart the Win2k systray...
                '
'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{730F6CDC-2C86-11D2-8773-92E220524153}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_SysTray)


'                Call DefineOLEGuid(IID_IUnknown, 0, 0, 0)
'                Call CLSIDFromString(StrConv("{20D04FE0-3AEA-1069-A2D8-08002B30309D}", vbUnicode), rclsid)
'                hr = CoCreateInstance(rclsid, 0, CLSCTX_INPROC_SERVER, IID_IUnknown, g_MyComputer)

