VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
    Option Explicit
Implements core.IBasePlugin
Private Sub IBasePlugin_StartPlugin(Name As String)
        
    Set oServer = CreateObject("core.CServer")
    oServer.RegisterBang Name, "!hide"
    oServer.RegisterBang Name, "!show"
    oServer.RegisterBang Name, "!toggle"
    oServer.RegisterBang Name, "!command3"
    oServer.RegisterBang Name, "!command4"
    
    m_Items = 0
    ReDim curTray(0)
    m_sName = Name
    Load frmSystray
    frmSystray.Left = oServer.evalNum(oServer.GetKey(Name, "x")) * Screen.TwipsPerPixelX
    frmSystray.Top = oServer.evalNum(oServer.GetKey(Name, "y")) * Screen.TwipsPerPixelY
    frmSystray.Width = oServer.evalNum(oServer.GetKey(Name, "width")) * Screen.TwipsPerPixelX
    frmSystray.Height = oServer.evalNum(oServer.GetKey(Name, "height")) * Screen.TwipsPerPixelY
    frmSystray.BackColor = oServer.GetKey(Name, "bgcolor")
    frmSystray.Picture1(0).BackColor = oServer.GetKey(Name, "bgcolor")
    If oServer.evalBool(oServer.GetKey(Name, "alwaysontop")) Then
        SetWindowPos frmSystray.hWnd, HWND_TOPMOST, frmSystray.Left / Screen.TwipsPerPixelX, frmSystray.Top / Screen.TwipsPerPixelY, frmSystray.Width / Screen.TwipsPerPixelX, frmSystray.Height / Screen.TwipsPerPixelY, SWP_NOACTIVATE Or SWP_SHOWWINDOW
    End If
    If Not oServer.evalBool(oServer.GetKey(m_sName, "hidden")) Then
        frmSystray.Visible = True
    End If
    StartUp

End Sub
Private Sub IBasePlugin_StopPlugin()

    If m_hWnd Then
        Call DestroyWindow(m_hWnd)
        Call UnregisterClass(CLASS_TrayProc, ByVal 0&)
    End If
    
End Sub
Private Sub IBasePlugin_Bang(Name As String, Arguments As String)

    Select Case Name
    Case "!command3"
        frmSystray.Command3_Click
    Case "!command4"
        frmSystray.Command4_Click
    Case "!hide"
        If LCase(Arguments) = LCase(m_sName) Then
            frmSystray.Visible = False
        End If
    Case "!show"
        If LCase(Arguments) = LCase(m_sName) Then
            frmSystray.Visible = True
            If oServer.evalBool(oServer.GetKey(m_sName, "alwaysontop")) Then
                SetWindowPos frmSystray.hWnd, HWND_TOPMOST, frmSystray.Left / Screen.TwipsPerPixelX, frmSystray.Top / Screen.TwipsPerPixelY, frmSystray.Width / Screen.TwipsPerPixelX, frmSystray.Height / Screen.TwipsPerPixelY, SWP_NOACTIVATE Or SWP_SHOWWINDOW
            End If
        End If
    Case "!toggle"
        If LCase(Arguments) = LCase(m_sName) Then
            frmSystray.Visible = Not frmSystray.Visible
        End If
    End Select
 
End Sub
Public Property Get IBasePlugin_Name() As String

    IBasePlugin_Name = m_sName

End Property
Private Function GetAddr(lpfnProc As Long) As Long
    GetAddr = lpfnProc
End Function
Private Sub StartUp()
    
    Dim wc As WNDCLASS
    Dim os As OSVERSIONINFO

    If FindWindow(CLASS_TrayProc, vbNullString) Then
        oServer.Execute "!log You can only run one instance of the systray module."
        Exit Sub
    End If

    os.dwOSVersionInfoSize = Len(os)
    Call GetVersionEx(os)

    g_fIsWindows2000 = IIf(os.dwMajorVersion >= 5, True, False)
    g_fIsNT = IIf(os.dwPlatformId = VER_PLATFORM_WIN32_NT, True, False)

    wc.lpfnwndproc = GetAddr(AddressOf TrayWndProc)
    wc.hCursor = LoadCursor(ByVal 0&, IDC_ARROW)
    wc.lpszClassName = CLASS_TrayProc

    If RegisterClass(wc) <> 0 Then
        '
        ' class registered okay
        '
        m_hWnd = CreateWindowEx(WS_EX_TOOLWINDOW, CLASS_TrayProc, vbNullString, WS_POPUP, 0, 0, 0, 0, 0, 0, ByVal 0&, ByVal 0&)
        
        If m_hWnd = 0 Then
            '
            ' oopsh, window wasn't created!
            '
            oServer.Execute "!log couldn't create systray window."
            Call UnregisterClass(CLASS_TrayProc, ByVal 0&)
        Else
            '
            ' from geO's SysTray service: add a timer to
            ' restart systray.exe
            '
            Call SetTimer(m_hWnd, 0&, 500&, 0&)
        End If
    Else
        oServer.Execute "!log couldn't register systray window class."
    End If

End Sub

